#include "Game.h"
#include "Player.h"
#include "Enemy.h"

//libsdl-image1.2-dev\

Game* Game::s_pInstance = 0;
bool Game::init(const char* title, int xpos, int ypos, int high, int width, int flags)
{

    m_bRunning = true;
    if(SDL_Init(SDL_INIT_EVERYTHING) < 0 )
    {
        printf("SDL could not initialize! SDL_Error: %s\n", SDL_GetError());
        m_bRunning = false;
    }
    else
    {
        m_pWindow = SDL_CreateWindow(title, xpos, ypos, high, width, flags);
        if(m_pWindow != 0)
        {
           g_pRenderer = SDL_CreateRenderer(m_pWindow, -1, 0);

           if(g_pRenderer != 0) // renderer init success
           {
                cout << "renderer creation success\n";
                SDL_SetRenderDrawColor(g_pRenderer, 80, 93, 237, 255);
           }
           else
           {
                cout << "renderer init fail\n";
                return false; // renderer init fail
           }
        }
        else
        {
            printf("Windows could not be created! SDL_Error: %s\n", SDL_GetError());
            m_bRunning = false;
        }
    }

    LoaderParams* pParamsPlayer = new LoaderParams(400,300,167, 167,"girl");
    LoaderParams* pParamsHowl = new LoaderParams(500, 700, 200, 137, "howl");
    LoaderParams* pParamsEnemy = new LoaderParams(100,100, 150, 152,"broom");
    LoaderParams* pParamsKing = new LoaderParams(900, 100, 150, 172, "king");
    LoaderParams* pParamsYaga = new LoaderParams(100, 100, 200, 290, "yaga_house");
    LoaderParams* pParamsKingdom = new LoaderParams(900, 100, 200, 273, "kingdom");
    LoaderParams* pParamsStart = new LoaderParams(500, 350, 100, 124, "start");
    LoaderParams* pParamsBack = new LoaderParams(0, 0, 1200, 900, "back");
    
    m_player = new Player(pParamsPlayer);
    m_howl = new Enemy(pParamsHowl);
    m_enemy = new Enemy(pParamsEnemy);
    m_king = new Enemy(pParamsKing);
    m_yaga_house = new Enemy(pParamsYaga);
    m_kingdom = new Enemy(pParamsKingdom);
    m_start = new Enemy(pParamsStart);
    m_back = new Enemy(pParamsBack);

    m_bRunning = TextureManager::Instance()->Load("assets/broom.png", "broom", g_pRenderer);
    m_bRunning = TextureManager::Instance()->Load("assets/girl_spritestrip.png", "girl", g_pRenderer);
    m_bRunning = TextureManager::Instance()->Load("assets/big-bad.png", "howl", g_pRenderer);
    m_bRunning = TextureManager::Instance()->Load("assets/king.png", "king", g_pRenderer);
    m_bRunning = TextureManager::Instance()->Load("assets/start.png", "start", g_pRenderer);
    m_bRunning = TextureManager::Instance()->Load("assets/podlozhka.png", "back", g_pRenderer);
    

//    m_go->load(200,200,250, 250,"girl");
//    m_player->load(300,300,250, 250, "girl");
//    m_enemy->load(100,100,80, 60,"monkey");
//    m_gameObjects.push_back(m_go);

    m_gameObjects.push_back(m_back);
    m_gameObjects.push_back(m_player);
    m_gameObjects.push_back(m_howl);
    m_gameObjects.push_back(m_enemy);
    m_gameObjects.push_back(m_king);
    m_gameObjects.push_back(m_start);
    
    //m_gameObjects.push_back(new Enemy(new LoaderParams(0, 300, 200, 290, "king")));

    return m_bRunning;

}

void Game::render()
{
    SDL_RenderClear(g_pRenderer);
    
    for(int i = 0; i != m_gameObjects.size(); i++)
    {
        m_gameObjects[i]->draw();
    }
    SDL_RenderPresent(g_pRenderer);
}

void Game::update()
{
    for(std::vector<GameObject*>::size_type i = 0; i!= m_gameObjects.size(); i++)
    {
        m_gameObjects[i]->update();
    }
    if(m_player->getPositionX() <= m_enemy->getPositionX() && m_player->getPositionY() <= m_enemy->getPositionY())
    {
        //std::cout << "ops";
        m_gameObjects.erase(m_gameObjects.begin()+2);
        m_bRunning = TextureManager::Instance()->Load("assets/babayagahouse.png", "yaga_house", g_pRenderer);
        m_gameObjects.push_back(m_yaga_house);
        
    }
    if(m_player->getPositionX() >= m_king->getPositionX() && m_player->getPositionY() >= m_king->getPositionY())
    {
        //std::cout << "ops";
        m_gameObjects.erase(m_gameObjects.begin()+3);
        m_bRunning = TextureManager::Instance()->Load("assets/kingdom.png", "kingdom", g_pRenderer);
        m_gameObjects.push_back(m_kingdom);
        
    }
    if(m_player->getPositionX() <= (m_howl->getPositionX()- 50) && m_player->getPositionY() <= (m_howl->getPositionY()- 50))
    {
        //std::cout << "am-am";
        m_player->getBack();
    }
    if((m_player->getPositionX() < 0) || (m_player->getPositionX() > 1050) || (m_player->getPositionY() < 0) || (m_player->getPositionY() > 730))
    {
        m_player->getStop();
    }
    //std::cout << "king X: " << m_king->getPositionX() << std::endl;
    //std::cout << "king Y: " << m_king->getPositionY()<< std::endl;
}

void Game::clean()
{
    
	SDL_DestroyWindow( m_pWindow );
    SDL_DestroyRenderer(g_pRenderer);
    SDL_Quit();
}

void Game::handleEvents()
{
    InputHandler::Instance()->update();
}
/*
std::map<std::string, Mix_Chunk*> m_sfxs;
std::map<std::string, Mix_Music*> m_music;
bool Game::SoundManager(std::string filename, std::string id, sound_type type)
{
    if(type == SOUND_MUSIC)
    {
        Mix_Music* pMusic = Mix_LoadMUS(filename.c_str()); 
        if(pMusic == 0)
        {
            std::cout << "mo load sound";
            return false;
        }
        m_music[id] = pMusic;
        return true;
    }
    else if(type == SOUND_SFX)
    {
        Mix_Chunk* pChunk = Mix_LoadWAV(filename.c_str());
        if(pChunk == 0)
        {
            std::cout << "not load SFX";
            return false;
        }
        m_sfxs[id] = pChunk;
        return true;
    }
    return false;
}*/