#include "TextureManager.h"

TextureManager* TextureManager::s_pInstance = 0;

bool TextureManager::Load(string fileName, string id, SDL_Renderer* pRenderer )
{
    
    SDL_Surface* pTempSurface = IMG_Load(fileName.c_str());

    if(pTempSurface == 0)
    {
        return false;
    }

    SDL_Texture* pTexture = SDL_CreateTextureFromSurface(pRenderer, pTempSurface);
    SDL_FreeSurface(pTempSurface);

    if(pTexture != 0)
    {
        m_textureMap[id] = pTexture;
        return true;
    }

    return false;
}


void TextureManager::Draw(string id, int x, int y, int with, int height, SDL_Renderer* pRenderer, SDL_RendererFlip flip)
{
   SDL_Rect srcRect;
   SDL_Rect destRect;

   srcRect.x = 0;
   srcRect.y = 0;
   srcRect.w = destRect.w = with;
   srcRect.h = destRect.h = height;
   destRect.x = x;
   destRect.y = y;

   SDL_RenderCopyEx(pRenderer, m_textureMap[id], &srcRect, &destRect, 0, 0, flip);
}

void TextureManager::DrawFrame(string id, int x, int y, int width, int height,int currentRow, int currentFrame, SDL_Renderer* pRenderer, SDL_RendererFlip SDL_FLIP_HORIZONTAL)
{
    
   SDL_Rect srcRect;
   SDL_Rect destRect;

   srcRect.x = 1 * currentFrame;
   srcRect.y = 1 * (currentRow - 1);
   srcRect.w = destRect.w = width;
   srcRect.h = destRect.h = height;
   destRect.x = x;
   destRect.y = y;

   //SDL_RenderCopy(pRenderer, m_textureMap[id], &srcRect, &destRect);


   SDL_RenderCopyEx(pRenderer, m_textureMap[id], &srcRect, &destRect, 0, 0, SDL_FLIP_HORIZONTAL);
}
